#include <iostream>
#include <string>
#include <vector>

using namespace std;

void sort_cards(string& card1, string& card2, string& card3){
  string low, mid, high;
  if(card1[0] < card2[0]){
    if(card1[0] < card3[0]){
      low = card1;
      if(card2[0] < card3[0]){
	mid = card2;
	high = card3;
      }
      else{
	mid = card3;
	high = card2;
      }
    }
    else{
      low = card3;
      mid = card1;
      high = card2;
    }
  }
  else{
    if(card2[0] < card3[0]){
      low = card2;
      if(card1[0] < card3[0]){
	mid = card1;
	high = card3;
      }
      else{
	mid = card3;
	high = card2;
      }
    }
    else{
      low = card3;
      mid = card2;
      high = card1;
    }
  }
  card1 = low;
  card2 = mid;
  card3 = high;

}

//what do the values on the cards add up to?
int add_cards(string card1, string card2, string card3){
  return card1[0] -'0' + card2[0] - '0' + card3[0] - '0';
}

//what rank do the cards make?  1= SF, 2 = 3oK, 3 = Flush, 4 = straight, 
// 5= nothing
int rank_cards(string card1, string card2, string card3){
  // easy check first- 3 of a kind
  if(card1[0] == card2[0] && card2[0] == card3[0])
    return 2;
  // put the cards in numerical order
  sort_cards(card1, card2, card3);
  //do we have a straight?
  if(card1[0] == card2[0] -1 && card2[0] == card3[0] -1){
    // do we have a straight flush?
    if(card1[1] == card2[1] && card2[1] ==card3[1])
      return 1;
    else // regular straight
      return 4;
  }
  else{ // no straight, do we have a flush?
    if(card1[1] == card2[1] && card2[1] == card3[1])
      return 3;
    else // we have nothing
      return 5;
  }
}

int main(){
  int cur_problem = 1;
  vector<string> cards(6);
  cin >> cards[0];
  while(cards[0][0] != '0'){
    for(int i = 1; i < 6; i++)
      cin >> cards[i];
    int first_sum = add_cards(cards[0], cards[1], cards[2]);
    int second_sum = add_cards(cards[3], cards[4], cards[5]);
    int first_rank = rank_cards(cards[0], cards[1], cards[2]);
    int second_rank = rank_cards(cards[3], cards[4], cards[5]);
    if(first_rank < second_rank || (first_rank == second_rank && 
				    first_sum > second_sum)) // player 1 wins
      cout << "Hand " << cur_problem << ": Player 1 wins." << endl;
  
    if(first_rank > second_rank || (first_rank == second_rank &&
				    first_sum < second_sum)) //player 2 wins
      cout << "Hand " << cur_problem << ": Player 2 wins." << endl;
    if(first_rank == second_rank && first_sum == second_sum)
      cout << "Hand " << cur_problem << ": There is a tie." << endl;
    cur_problem++;
    cin >> cards[0];


  }
  return 0;
}
