#include <iostream>
#include <cmath>
#include <vector>

using namespace std;


class point{
public:
  int x;
  int y;
};


//does segment (a,b) intersect segment (c,d)?
// (a,b) is always horizontal
bool intersects(point a, point b, point c, point d){
  //is (c,d) horizontal as well?
  if(c.y == d.y)
    return false; // no possible intersection
  // is (a,b) outside of the y-values of (c,d)?
  if(a.y > c.y && a.y > d.y)
    return false;
  if(a.y < c.y && a.y < d.y)
    return false;
  //is (c,d) vertical?
  if(c.x == d.x){
    //then see if that x coordinate is in between a and b's x coordinates
    if(c.x > a.x && c.y < b.x)
      return true;
    else
      return false;
  }


  //otherwise, find the slope of (c,d)
  double slope = (double)(c.y - d.y)/(double) (c.x - d.x);
  // solve for x coordinate when y coordanate is a.y
  double x_coord = (a.y - c.y + slope*c.x)/slope;
  if(x_coord > min(c.x, d.x) && x_coord < max(c.x,d.x) && x_coord < b.x)
    return true;
  else
    return false;
}

// is p inside triangle (a,b,c)?
bool inside(point p, point a, point b, point c){
  //p = (x,y) is inside the triangle if the line extending from (-inf, y) to 
  // (x,y) intersects exactly one of the segments (a,b), (b,c), and (a,c).
  // since all coordinates are positive integers, we can use -1 for -inf
  int num_intersects = 0;
  point left_point;
  left_point.x = -1;
  left_point.y = p.y;
  if(intersects(left_point, p, a, b))
    num_intersects++;
  if(intersects(left_point, p, a, c))
    num_intersects++;
  if(intersects(left_point, p, b, c))
    num_intersects++;
  return num_intersects==1;
}

int main(){
  int n;
  cin >> n;
  for(int i = 1; i <=n; i++){
    vector<point> claim1(3);
    vector<point> claim2(3);
    cin >> claim1[0].x >> claim1[0].y 
	>> claim1[1].x >> claim1[1].y
        >> claim1[2].x >> claim1[2].y;
    cin >> claim2[0].x >> claim2[0].y
        >> claim2[1].x >> claim2[1].y
        >> claim2[2].x >> claim2[2].y;
    //see if points from triangle 1 are inside triangle2
    int claim1_inside = 0;
    for(int j = 0; j < 3; j++){
      if(inside(claim1[j], claim2[0], claim2[1], claim2[2]))
	claim1_inside++;
    }
    //see if points from triangle 2 are inside triangle1
    int claim2_inside = 0;
    for(int j = 0; j < 3; j++){
      if(inside(claim2[j], claim1[0], claim1[1], claim1[2]))
	claim2_inside++;
    }

    if(claim1_inside == claim2_inside){ // case where they're equal
      cout << "Case " << i << ": Both claims have equal numbers of intruding points: " << claim1_inside << endl;
    }
    else{
      if(claim1_inside > claim2_inside){
	cout << "Case " << i << ": Claim 1 has " << claim1_inside 
	     << " vertices inside Claim 2." << endl;
      }
      else{
	cout << "Case " << i << ": Claim 2 has " << claim2_inside
	     << " vertices inside Claim 1." << endl;
      }
    }
  }
  return 0;
}
      
      
