#include <iostream>
#include <string>
#include <vector>

using namespace std;

int num_letters;
string best_solution;
//pops out if a value is -1
bool Verify(vector<int>& op1, vector<int>& op2, vector<int>& sum){
  int carry = 0;
  
  for(int i = 0; i < sum.size(); i++){
    int num1, num2;
    if(i >= op1.size())
      num1 = 0;
    else
      num1 = op1[op1.size()-i-1];
    if(num1 == -1)
      return true;
    if(i >= op2.size())
      num2 = 0;
    else
      num2 = op2[op2.size()-i-1];
    if(num2 == -1)
      return true;
    
    
    int check_digit = sum[sum.size()-i-1];
    if(check_digit == -1)
      return true;
    int cur_sum = num1 + num2 + carry;
    if(cur_sum >=10){
      carry = 1;
      cur_sum = cur_sum -10;
    }
    else
      carry = 0;
    if(cur_sum != sum[sum.size()-i-1])
      return false;
  }
  if(carry == 0)
    return true;
  else
    return false;
}

void Print_Numbers(vector<int>& op1, vector<int>& op2, vector<int>& sum){
  for(int i = 0; i < op1.size(); i++)
    cout << op1[i];
  cout << " + ";
  for(int i = 0; i < op2.size(); i++)
    cout << op2[i];
  cout << " = ";
  for(int i = 0; i < sum.size(); i++)
    cout << sum[i];
  cout << endl;
}


int max3(int a, int b, int c){
  if(a > b){
    if(a > c)
      return a;
    else
      return c;
  }
  else{
    if(b > c)
      return b;
    else
      return c;
  }
}
bool Solve(int which_letter, string op1_str, string op2_str, string sum_str, 
	   vector<int>& op1, vector<int>& op2, vector<int>& sum, 
	   vector<bool>& taken, string cur_solution){
  
  // Print_Numbers(op1, op2, sum);
  if(!Verify(op1, op2, sum))// incorrect sum popout
     return false;
else{ // find a number for this letter
  if(which_letter == num_letters){ // no letters left, and a verified answer
    return true; 
    
  }
  char cur_letter;
  //the letter to check for is the rightmost one we haven't replaced yet
   for(int i = max3(op1.size(), op2.size(), sum.size())-1; i >=0; i--){
    if(i < op1.size() && op1[i] == -1){
      cur_letter = op1_str[i];
      i = -1;
    }
    if(i!= -1 && i < op2.size() && op2[i] == -1){
      cur_letter = op2_str[i];
      i = -1;
    }
    if(i!= -1 && i < sum.size() && sum[i] == -1){
      cur_letter = sum_str[i];
    }
   }  
  //   cur_letter = which_letter + 'A';
    for(int i = 0; i < 10; i++){
      if(!taken[i]){ //number availible
	for(int j = 0; j < op1_str.size(); j++){
	  if(op1_str[j] == cur_letter)
	    op1[j] = i;
	}
	for(int j = 0; j < op2_str.size(); j++){
	  if(op2_str[j] == cur_letter)
	    op2[j] = i;
	}
	for(int j = 0; j < sum_str.size(); j++){
	  if(sum_str[j] ==  cur_letter)
	    sum[j] = i;
	}
	taken[i] = true;
	cur_solution[cur_letter -'A'] = i;

	if(Solve(which_letter+1, op1_str, op2_str, sum_str, op1, op2, sum, taken, cur_solution)){
	  if(cur_solution < best_solution)
	    best_solution = cur_solution;
	  /*	  cout << "found: ";
	  Print_Numbers(op1, op2, sum);
	  for(int i = 0; i < cur_solution.size(); i++){
	    cout << (char)(cur_solution[i]+'0')<< " ";
	  }
	  cout << endl;
	  */
	  //  return false; //force backtrack
	}
	//else, backtrack
	taken[i] = false;
	cur_solution[cur_letter - 'A'] = 0;
for(int j = 0; j < op1_str.size(); j++){
	  if(op1_str[j] == cur_letter)
	    op1[j] = -1;
	}
	for(int j = 0; j < op2_str.size(); j++){
	  if(op2_str[j] == cur_letter)
	    op2[j] = -1;
	}
	for(int j = 0; j < sum_str.size(); j++){
	  if(sum_str[j] == cur_letter)
	    sum[j] = -1;
	}
      }
    }
    return false;
  }
}


// Translates using the solution and prints the result
void Print_Translated_Numbers(string op1_str, string op2_str, string sum_string,
			      string best_solution){
  for(int i = 0; i < op1_str.size(); i++){
    cout << (char)(best_solution[op1_str[i]-'A'] + '0');
  }
  cout << " + ";
  for(int i = 0; i < op2_str.size(); i++){
    cout << (char)(best_solution[op2_str[i]-'A'] + '0');
  }
  cout << " = ";
  for(int i = 0; i < sum_string.size(); i++){
    cout << (char)(best_solution[sum_string[i]-'A'] + '0');
  }
  cout << endl;
}
int main(){

  string op1_str;
  string op2_str;
  string sum_str;
  char dummy;
 
  cin >> num_letters;
  while(num_letters>0){
    cin >> op1_str >> dummy >> op2_str >> dummy >> sum_str;
    
    vector<int> op1;
    op1.resize(op1_str.size(), -1);
    vector<int> op2;
    op2.resize(op2_str.size(), -1);
    vector<int> sum;
    sum.resize(sum_str.size(), -1);
    vector<bool> taken(10,false);
    string cur_solution = "0000000000";
    best_solution = "9999999999";
    //sanity check
    if(sum.size() < op1.size() || sum.size() < op2.size())
        cout << "No solution possible." << endl;
    else{
      Solve(0, op1_str, op2_str, sum_str, op1, op2, sum, taken, cur_solution);
      if(best_solution == "9999999999")
	cout << "No solution possible." << endl;
      else
	Print_Translated_Numbers(op1_str, op2_str, sum_str, best_solution);
    }

      

    cin >> num_letters;
  }
  return 0;
}
  

  
