#include <iostream>
#include <vector>

using namespace std;

//lame loop version
int pow (int b, int e){
  int product =1;
  for(int i = 0; i < e; i++)
    product = product *b;
  return product;
}

int who_lost_to(const vector<int>& results, int cur_loser, int cur_round){
  //the current round has 2^cur_round teams left
  int num_left = pow(2,cur_round);
  if(num_left == results.size()+1){ //opening round
    if(cur_loser %2 == 0) // even numbers beat the team below them
      return cur_loser-1;
    else
      return cur_loser+1;
  }
  else  {
    //that means that there are num_left-1 spots in the results array 
    //_after_ this round
    int end_range = results.size()-1  - (num_left -1);
    int start_range = end_range - num_left +1;
    //in that range, we're looking for a the team that played our cur_loser
    //In round 1 (the finals) we look at all the teams.  
    // In round 2, only teams in the half of the bracket with our loser is considered
    // In round 3, only teams in the quarter of the bracket.
    // in other words, the range of teams is n/2^(cur_round-1)
    int num_to_check = (results.size()+1)/pow(2, cur_round-1);
    //there are only two teams in our chunk of the bracket- the cur_loser, and 
    // the team we're looking for.  Find the range of teams we're looking for
    int low_team = (cur_loser-1) / num_to_check;
    low_team = low_team * num_to_check +1;
    int high_team = low_team + num_to_check;
    for(int i = start_range; i <= end_range; i++){
      if(results[i] >= low_team && results[i] <= high_team && 
	 results[i] != cur_loser)
	//then we've found the other team in the previous round that lost to us
	return results[i];
    }
    //we shouldn't get here
    cout << "Unable to find team that beat: " << cur_loser << " in round " << cur_round << endl;
  }
}
int main(){
  int n;
  cin >> n;
  int which_case = 1;
  while (n>0){
    vector<int> results(n-1);
    for(int i = 0; i < n-1; i++)
      cin >> results[i];
    int cur_round = 1; //counts backwards from the end
    int num_teams_left = 1;
    int cur_loser = results[n-2]; //start with the champion
    while(num_teams_left <n){
      cur_loser = who_lost_to(results, cur_loser, cur_round);
      cur_round++;
      num_teams_left = num_teams_left *2;
    }
    cout << "Case " << which_case << ": The ultimate loser is team " << cur_loser 
	 << "." <<endl;

    cin >> n;
    which_case++;
  }
  return 0;
}
