#include <iostream>
#include <string>
#include <vector>

using namespace std;


//returns the index of cur_name, creating a spot for it if needed
int find(vector<string>& names, string cur_name){
  for(int i = 0; i < names.size(); i++)
    if(names[i] == cur_name)
      return i;
  //if we get here it's not in the vector
  names.push_back(cur_name);
  return names.size()-1;
}

bool DFS_look(const vector<vector<bool> > & g, int cur_node, vector<int>& seen){
  seen[cur_node] = 1;
  for(int i = 0; i < g.size(); i++)
    if(g[cur_node][i]){ // edge exists
      if(seen[i] == 1) // then there's a cycle
	return true;
      else{
	if(seen[i] == 0) // then it hasn't been considered yet
	  if(DFS_look(g,i, seen))
	    return true;
      }
    }
  seen[cur_node] = 2;
  return false;

       
}
//returns true if g has a directed cycle, false otherwise.
bool find_cycles (const vector<vector<bool> >  & g){
  vector<int> seen(g.size(),0); // 0 = unseen, 2 = seen, 1 = seen on this path
  for(int i = 0; i < g.size(); i++)
    if(seen[i] == 0)
      if(DFS_look(g, i, seen))
	return true;
  return false;
}
int main(){
  vector<string> names;
  vector<vector<bool> > refs;
  int n;
  cin >> n;
  int cur_set = 1;
  while(n>0){
    refs.resize(n);
    for(int i = 0; i < n; i++)
      refs[i].resize(n,false);
    for(int j = 0; j < n; j++){
      string cur_name;
      cin >> cur_name;
      int m;
      cin >> m;
      int page_loc = find(names, cur_name);
      for(int i = 0; i < m; i++){
	string cur_ref;
	cin >> cur_ref;
	int ref_loc = find(names, cur_ref);
	refs[page_loc][ref_loc] = true; // page_loc refers to ref_loc
      }
    }
    vector<vector<bool> > dominance(n);
    for(int i = 0; i < n; i++)
      dominance[i].resize(n, false);

    //build the graph of dominance
    for(int i = 0; i < n; i++)
      for(int j = 0; j < n; j++)
	if(refs[i][j] && !refs[j][i])// i refers to j but j doesn't refer to i
	  dominance[j][i] = true; // j dominates i

    if(find_cycles(dominance))
      cout << "Case " << cur_set << ": There is a dominating circle." << endl;
    else
      cout << "Case " << cur_set << ": There is no dominating circle." << endl;

    cur_set++;
    cin >> n;
    names.resize(0);
    refs.resize(0);
  }
  return 0;
}
    
    
    
